#include "allwx.hpp"
#include "dch.hpp"
#include "winmenu.hpp"
#ifdef __SC__
#include <direct.h>
#endif
#include <ctype.h>

#define VERSION "1.6i"

#include <wx_help.h>

wxHelpInstance *HelpInstance = NULL;

dcwindow input_window(NULL,"QDB message",7,6,10,73);
// global so can keep history

void help_message(char *message,va_list arg_ptr)
{
char buff[200];
vsprintf(buff,message,arg_ptr);
wxMessageBox(buff,"",wxOK,mainframeptr,10,30);
}

enum main_choice_t {
LOAD_HEADER=1, REINDEX, CHANGE_INDEX, DBF_FROM_HEADER,
HEADER_FROM_DBF, CHDIR, QUIT, MODIFY_RECORDS, ADD_NEW_RECORDS, UNDELETE_RECORDS,
ALL_RECORDS, INPUT_SELECTION_CRITERION, CRITERION_FROM_FILE, IMPORT_SDF,
RECORD_SPECIFIC_SDF_IMPORT,IMPORT_DBF,FIELD_SPECIFIC_DBF_IMPORT,
EXPORT_SDF,EXPORT_DBF,RECALCULATE,CALCULATOR, QDB_HELP, QDB_ABOUT
} main_choice;

int im_busy=0,first_time=1;
char hdr_spec[100],hdr_fn[100],rep_spec[100],rep_fn[100],rep_out_spec[100],
rep_out_fn[100],sel_spec[100],sel_fn[100],sdf_spec[100],sdf_fn[100],
dbf_spec[100],dbf_fn[100],new_fn[100];

dch *h;

class AltKeyWindow: public wxTextWindow
{
public:
AltKeyWindow(wxFrame *frame, int x=-1, int y=-1, int width=-1, int height=-1,
               long style=0):
  wxTextWindow(frame, x, y, width, height, wxNATIVE_IMPL)  { ; }
  void OnChar(wxKeyEvent& event);
};

void AltKeyWindow::OnChar(wxKeyEvent& event)
{ if (!isprint(event.keyCode)) wxTextWindow::OnChar(event); }

// This statement initializes the whole application and calls OnInit
MyApp myApp;

MyFrame *mainframeptr;
// `Main program' equivalent, creating windows and returning main app frame
wxFrame *MyApp::OnInit(void)
{
  // Create the main frame window
  MyFrame *frame = new MyFrame(NULL, "WQDB v"VERSION, 0, 0, 400, 100);
mainframeptr=frame;

#ifdef wx_msw
  // Give it an icon
  frame->SetIcon(new wxIcon("qdb_icn"));
#endif

  // Make a menubar

  wxMenu *file_menu = new wxMenu;
  wxMenu *record_menu = new wxMenu;
  wxMenu *report_menu = new wxMenu;
  wxMenu *utility_menu = new wxMenu;

  file_menu->Append(LOAD_HEADER,"&Load header");
  file_menu->Append(REINDEX,"&Reindex");
  file_menu->Append(CHANGE_INDEX,"Change &index");
  file_menu->Append(DBF_FROM_HEADER,"&DBF from header");
  file_menu->Append(HEADER_FROM_DBF,"&Header from DBF");
  file_menu->Append(CHDIR,"&Change working directory");
  file_menu->Append(QUIT,"&Quit");

  record_menu->Append(MODIFY_RECORDS,"&Modify records");
  record_menu->Append(ADD_NEW_RECORDS,"&Add new records");
  record_menu->Append(UNDELETE_RECORDS,"&Undelete records");

  report_menu->Append(ALL_RECORDS,"&All records");
  report_menu->Append(INPUT_SELECTION_CRITERION,"Input selection &criterion");
  report_menu->Append(CRITERION_FROM_FILE,"Criterion from &file");

  utility_menu->Append(IMPORT_SDF,"&Import SDF");
  utility_menu->Append(RECORD_SPECIFIC_SDF_IMPORT,"Record-specific &SDF import");
  utility_menu->Append(IMPORT_DBF,"Import &DBF");
  utility_menu->Append(FIELD_SPECIFIC_DBF_IMPORT,"&Field-specific DBF import");
  utility_menu->Append(EXPORT_SDF,"&Export SDF");
  utility_menu->Append(EXPORT_DBF,"E&xport DBF");
  utility_menu->Append(RECALCULATE,"&Recalculate all records");
  utility_menu->Append(CALCULATOR,"&Calculator");

    wxMenu *help_menu = new wxMenu;

#ifdef wx_msw
    help_menu->Append(QDB_HELP, "&Help", "QDB Contents Page");
#endif
    help_menu->Append(QDB_ABOUT, "&About QDB", "About QDB");


  wxMenuBar *menu_bar = new wxMenuBar;
  menu_bar->Append(file_menu, "&File");
  menu_bar->Append(record_menu, "&Records");
  menu_bar->Append(report_menu, "Re&ports");
  menu_bar->Append(utility_menu, "&Utility");
  menu_bar->Append(help_menu, "&Help");

  frame->SetMenuBar(menu_bar);

#ifdef wx_msw
    HelpInstance = new wxHelpInstance(TRUE);
    HelpInstance->Initialize("wqdb");
#endif

  wxTextWindow *key_catcher = new AltKeyWindow(frame); // to get character events
  // Make a panel with a message
  wxPanel *panel = new wxPanel(frame, 0, 0, 400, 300);
  (void)new wxMessage(panel, "QDB (wxWindows version)");
  panel->NewLine();
  (void)new wxMessage(panel, "Copyright Dave Curtis 1990-4");
  // Return the main frame window

dcerror.warn();
dcerror.set_display(help_message);
input_window.set_history(1000);
if (argc>1)
  {
  strcpy(hdr_fn,argv[1]);
  if ((h=new dch)==NULL) dcerror(ENOMEM);
  h->load(hdr_fn,NULL);
  }
frame->Show(TRUE);
frame->LoadAccelerators("menus_accel") ;
return frame;
}

// My frame constructor
MyFrame::MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h):
  wxFrame(frame, title, x, y, w, h)
{}

Bool MyFrame::OnClose(void)
{ return !im_busy; }
// I cannot be bothered to keep track of all subframes

// Intercept menu commands
void MyFrame::OnMenuCommand(int id)
{
char line_buff[2000];
int overwrite,nomore;
if (im_busy) return;
im_busy=1;
winmenu list_menu(8,7),choice_menu(8,7);
if (first_time)
  {
  strcpy(hdr_spec,"*.hdc");
  strcpy(rep_spec,"*.rep");
  strcpy(rep_out_spec,"*.*");
  strcpy(sel_spec,"*.sel");
  strcpy(sdf_spec,"*.sdf");
  strcpy(dbf_spec,"*.dbf");
  }
winmenu modmenu(2,20,"First^Last^Previous^Next^Select^Match^Search^Again^Current^Delete");
dcerror.clear(); // I think OK to do this here
int OK;
if (id!=LOAD_HEADER && id!=QUIT && id!=CHDIR &&
      id!=DBF_FROM_HEADER && id!=HEADER_FROM_DBF &&
      id!=QDB_HELP && id!=QDB_ABOUT &&
         (!h || !h->is_OK()))
        dcerror(1,"No header loaded");
else switch (id)
  {
  case LOAD_HEADER:
          *hdr_fn='\0';
          if (choose_file(hdr_fn,hdr_spec,input_window,list_menu))
            {
            if (h==NULL && (h=new dch)==NULL) dcerror(ENOMEM);
            h->load(hdr_fn,NULL);
            }
          break;
  case REINDEX:
          input_window.clear();
          input_window.puts("Rebuilding indices...");
          if (h->rebuild_indices())
            input_window.puts("..OK");
          break;
  case CHANGE_INDEX:
          h->choose_index(list_menu);
          break;
  case DBF_FROM_HEADER:
          *line_buff='\0';
          if (!choose_file(line_buff,hdr_spec,input_window,list_menu,
              "Select file to create DBF file from")) break;
          if (h==NULL && (h=new dch)==NULL) dcerror(ENOMEM);
          else h->dbf_from_hdc(line_buff);
          break;
  case HEADER_FROM_DBF:
          {
          data_file hf;
          *line_buff='\0';
          if (!choose_file(line_buff,dbf_spec,input_window,list_menu,
              "DBF file to create header from") ||
              !hf.open(line_buff,"rb")) break;
          *line_buff='\0';
          if (!choose_file(line_buff,hdr_spec,input_window,list_menu,
              "Provide file name for new header")) break;
          db3_header *hdr;
          hdr=new db3_header(&hf);
          if (!hdr) break;
          if (!hdr->load()) { delete hdr; break;}
          hdr->make_hdc(line_buff);
          delete hdr;
          break;
          }
  case CHDIR:
          input_window.clear();
          *line_buff='\0';
          if (input_window.gets(line_buff,1000,"Enter directory to change to:\n"))
            chdir(line_buff);
//wxExecute(line_buff);
          break;
  case MODIFY_RECORDS:
          int ccc;
          if (!h->goto_first())
            { dcerror(0,"Database appears to be empty"); break; }
          while (OK=1,ccc=modmenu.choose())
           {
           switch (ccc)
            {
            case 1: OK=h->goto_first(); break;
            case 2: OK=h->goto_last(); break;
            case 3: OK=h->goto_prev(); break;
            case 4: OK=h->goto_next(); break;
            case 5:
              if (h->get_curr_index()!=0)
                OK=h->select_from_index(list_menu);
              else OK=0,dcerror(0,"Must specify an index first");
              break;
            case 6:
              line_buff[0]='\0';
              input_window.clear();
              OK=input_window.gets(line_buff,1000,"Enter string to match to current index\n")
                 && h->goto_near_match(line_buff);
              input_window.suspend();
              break;
            case 7:
              line_buff[0]='\0';
              input_window.clear();
              if (!input_window.gets(line_buff,1000,"Enter expression to search for\n"))
                { OK=0; break; }
              input_window.suspend();
              if ((OK=h->search_for_expr(line_buff))==0)
                dcerror(0,"No records found which match search expression");
              break;
            case 8:
              if ((OK=h->search_for_expr())==0)
                dcerror(0,"No more records found which match search expression");
              break;
            case 9: // just stay at current record
              break;
            case 10:
              int pn;
              do {
                 if (!h->header->record_load(*h->buffer))
                   break;
                 pn=h->delete_one();
                 } while (pn==2 || pn==3);
              break;
            }
           if (OK && ccc!=10)
             {
             int pn;
             do {
                if (ccc!=6 && ccc!=7 && !h->header->record_load(*h->buffer))
                   break;
                pn=h->edit_one();
                if (pn==2 && !h->goto_prev())
                  pn=1;
                else if (pn==3 && !h->goto_next())
                  pn=1;
                ccc=1;
                } while (pn==2 || pn==3);
             }
           if (!OK && (ccc==1 || ccc==2))
            { dcerror(0,"Database appears to be empty"); break; }
           }
          modmenu.suspend();
          break;
  case ADD_NEW_RECORDS:
          while (h->add_one()) ; break;
  case UNDELETE_RECORDS:
          h->goto_first(0,0);
          nomore=0;
          for (;;)
            {
            while (!h->header->rec_is_deleted())
              if (h->header->get_this_rec()==h->header->get_num_recs()
                   || !h->goto_next(0,0))
                { dcerror(0,"No more deleted records found"); nomore=1; break; }
            if (nomore) break;
            if (h->undelete_one()==3) continue; // OK-Next pressed
            if (choice_menu.choose("Find other deleted records^Stop undeleting")!=1) break;
            else if (!h->goto_next(0,0))
                { dcerror(0,"No more deleted records found"); nomore=1; break; }
                // was on last one in file
            }
          break;
  case ALL_RECORDS:
  case INPUT_SELECTION_CRITERION:
  case CRITERION_FROM_FILE:
         *line_buff='\0';
          if (!choose_file(rep_fn,rep_spec,input_window,list_menu,
              "Select file containing report commands:"))break;
          if (id==INPUT_SELECTION_CRITERION)
            {
            *line_buff='\0';
            input_window.clear();
            if (!input_window.gets(line_buff,1000,
              "Enter expression to select records:")) break;
            input_window.suspend();
            }
          else if (id==CRITERION_FROM_FILE)
            if (!choose_file(sel_fn,sel_spec,input_window,list_menu,
              "Select file to read selection criterion from:")) break;
            else
              {
              data_file sel_cri;
              if (!sel_cri.open(sel_fn,"r") || !sel_cri.fgets(line_buff,1000)) break;
              }
          while (1)
              {
              if (!choose_file(rep_out_fn,rep_out_spec,input_window,list_menu,
                 "Select file to write output to:")) goto broke_out;
              if (!strcmp(rep_fn,rep_out_fn))
                 {
                 dcerror(1,"Report file and output file have same name");
                 continue;
                 }
              FILE *test;
              if ((test=fopen(rep_out_fn,"r"))!=NULL)
                {
                fclose(test);
                char s[100];
                sprintf(s,"File %s already exists. Overwrite it?",rep_out_fn);
                int ans=wxMessageBox(s,"",wxYES_NO|wxCANCEL,mainframeptr);
                if (ans==wxNO) continue;
                if (ans==wxCANCEL) goto broke_out;
                }
              break;
              }
          input_window.clear();
          input_window.puts("Generating report...");
          if (!h->run_report(rep_fn,rep_out_fn,line_buff)) break;
          input_window.puts("..OK");
          if (id==INPUT_SELECTION_CRITERION &&
                choose_file(sel_fn,sel_spec,input_window,list_menu,
              "If desired select file to save selection criterion to:"))
            {
            data_file sel_cri;
            if (sel_cri.open(sel_fn,"w")) sel_cri.fprintf("%s",line_buff);
            }
          broke_out:
          break;
  case IMPORT_SDF:
  case RECORD_SPECIFIC_SDF_IMPORT:
          if (!choose_file(sdf_fn,sdf_spec,input_window,list_menu,
            "Select SDF file to import from:")) break;
          if (id==IMPORT_SDF)
            {
            overwrite=choice_menu.choose("Append new records^Overwrite old records");
            if (overwrite==0) break;
            else --overwrite;
            if (overwrite &&
              choice_menu.choose("Don't really overwrite^Yes, really overwrite!")!=2)
              break;
            input_window.clear();
            input_window.puts("Importing records...");
            if (h->import_sdf(sdf_fn,overwrite))
              input_window.puts("..OK");
            input_window.puts("Rebuilding indices...");
            if (h->rebuild_indices())
              input_window.puts("..OK");
            }
          else
            {
            input_window.clear();
            input_window.puts("Importing data...");
            if (h->import_sdf_by_record(sdf_fn))
              input_window.puts("..OK");
            }
          break;
  case IMPORT_DBF:
  case FIELD_SPECIFIC_DBF_IMPORT:
          if (!choose_file(dbf_fn,dbf_spec,input_window,list_menu,
            "Select SDF file to import from:")) break;
          overwrite=choice_menu.choose("Append new records^Overwrite old records");
          if (overwrite==0) break;
          else --overwrite;
          if (overwrite &&
              choice_menu.choose("Don't really overwrite^Yes, really overwrite!")!=2)
              break;
          input_window.clear();
          *line_buff='\0';
          input_window.gets(line_buff,1000,
            "Enter selection criterion or leave blank to import all records");
          input_window.suspend();
          input_window.clear();
          input_window.puts("Importing records...");
          if (id==IMPORT_DBF) OK=h->import_dbf(dbf_fn,overwrite,line_buff);
          else OK=h->import_dbf_matching_fields(dbf_fn,overwrite,line_buff);
          if (OK) input_window.puts("..OK");
          input_window.puts("Rebuilding indices...");
          if (h->rebuild_indices())
            input_window.puts("..OK");
          break;
        case EXPORT_SDF:
        case EXPORT_DBF:
          *new_fn='\0';
          if (id==EXPORT_SDF)
            {
            if (!choose_file(new_fn,sdf_spec,input_window,list_menu,
              "Select name of SDF file to export:")) break;
            }
          else if (!choose_file(new_fn,dbf_spec,input_window,list_menu,
            "Select name of DBF file to export:")) break;
          *line_buff='\0';
          input_window.gets(line_buff,1000,
            "Enter selection criterion or leave blank to export all records");
          input_window.clear();
          input_window.puts("Exporting records...");
          if (id==EXPORT_SDF) OK=h->export_sdf(new_fn,line_buff);
          else OK=h->export_dbf(new_fn,line_buff);
          if (OK) input_window.puts("..OK");
          break;
        case RECALCULATE:
          input_window.clear();
          *line_buff='\0';
          input_window.gets(line_buff,1000,
            "Enter selection criterion or leave blank to recalculate all records");
          input_window.clear();
          input_window.puts("Recalculating records...");
          if (h->recalc_all(line_buff))
            input_window.puts("..OK");
          break;
        case CALCULATOR:
          db_express *expr;
          dcexpr_val *rv;
          if ((expr=new db_express(h->buffer))==NULL) { dcerror(ENOMEM); break; }
          while (*line_buff='\0',
                 input_window.gets(line_buff,1000,"Enter expression to evaluate:\n"))
              {
              if (!expr->parse(line_buff)) continue;
              rv=expr->eval();
              char *answer=(char*)(*rv); // just for debugging
              wxMessageBox(answer, "Result",wxOK);
#if 0
              input_window.clear();
              input_window.printf("%s",line_buff);
              input_window.printf("\nResult: \"%s\"",(char*)(*rv));
#endif
              delete rv;
              }
           delete expr;
           input_window.suspend();
           break;
#ifdef wx_msw
    case QDB_HELP:
    {
      HelpInstance->LoadFile();
      HelpInstance->DisplayContents();
      break;
    }
#endif
    case QDB_ABOUT:
    {
      char buf[300];
#ifdef wx_msw
      sprintf(buf, "QDB version %s\nBy Dave Curtis dcurtis@hgmp.mrc.ac.uk",VERSION);
#else
      sprintf(buf, "QDB version %s\nBy Dave Curtis dcurtis@hgmp.mrc.ac.uk\n\nUse supplied HTML files for online help",VERSION);
#endif
      wxMessageBox(buf, "About QDB");
      break;
    }
  case QUIT:
#if 0 // def wx_xview
// flakey with exceedw/winsock
    wxExit();
#else
//"correct way"
    im_busy=0;
    OnClose();
    delete this;
#endif
    break;
  }
if (id!=QUIT) mainframeptr->Iconize(FALSE);
im_busy=0;
}



